{**********************************************************************
          Copyright (c) PilotLogic Software House.
                   All rights reserved.
  
 Package pl_OnGuard.pkg
 This unit is part of CodeTyphon Project (http://www.pilotlogic.com/)
***********************************************************************}

unit onguardstarter;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,
  ogfirst,
  ogsrmgr,
  ogutil,
  onguard,
  ConsoleStubs;

Procedure OnGuard_Init_StringResource;  // this will call and OnGuard_Init
Procedure OnGuard_Init_FirstInstance;   // this will call and OnGuard_Init
Procedure OnGuard_Init;                 // Simple init
Procedure OnGuard_Stop;                 // Stop ALL


implementation

var
 _EngineHasInit:boolean         =False;
 _StringResourceHasInit:boolean =False;
 _FirstInstanceHasInit:boolean  =False;

//================================================

Procedure OnGuard_Init;
begin
  if _EngineHasInit then exit;

  _Init_onguard;
  _Init_ogutil;
  _Init_ConsoleStubs;

  _EngineHasInit:=true;
end;

Procedure OnGuard_Init_StringResource;
begin
  if _StringResourceHasInit then exit;
  if _EngineHasInit=false then OnGuard_Init;

  _Init_ogsrmgr;
  _StringResourceHasInit:=true;
end;

Procedure OnGuard_Init_FirstInstance;
begin
  if _FirstInstanceHasInit then exit;
  if _EngineHasInit=false then OnGuard_Init;

  _Init_ogfirst;
  _FirstInstanceHasInit:=true;
end;

Procedure OnGuard_Stop;
begin
   if _StringResourceHasInit then _Stop_ogfirst;
   if _FirstInstanceHasInit  then _Stop_ogsrmgr;
end;

end.

